package com.maroontress.sanctuary;

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
*/
public class Export implements Compound {

    /** 롼 */
    private Group group;

    /** "struct" ޤ "union" ޤ "eunm" */
    private String type;

    /** ̾ */
    private QualifiedName name;

    /** descǤ */
    private Description desc;

    /**
       ݡȤޤ

       @param g 롼
       @param elem export
    */
    public Export(final Group g, final Element elem) {
	group = g;
	type = elem.getAttribute("type");
	QualifiedName tag = g.expandNS(elem, "tag");
	name = QualifiedName.prepend(type + " ", tag);
	g.importTag(type, tag.getQualified());

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       ̾ޤ

       @return ̾
    */
    public QualifiedName getName() {
	return name;
    }

    /**
       ݡȤΥפޤ

       @return "struct" ޤ "union" ޤ "eunm"

    */
    public String getType() {
	return type;
    }

    public final void printCompoundSummary(final PrintWriter wr) {
	String fieldName = "<b>" + group.getHTML(name.getQualified()) + "</b>";

	wr.println(""
+ "    <table width=\"100%\" cellspacing=\"0\" border=\"1\">\n"
+ "      <tr>\n"
+ "        <td colspan=\"2\"><font size=\"+1\">" + fieldName + "</font><br>\n"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "        </tr>\n"
+ "    </table><br>");
    }

    public final void printCompoundDetail(final PrintWriter wr) {
	String fieldName = "<b>" + name.getSimple() + "</b>";

	wr.println(""
+ "<p><a name=\"" + name.getQualified() + "\"></a>\n"
+ "<font size=\"+1\">" + fieldName + "</font></p>\n"
+ "<dl><dd>" + desc.getText()
+ "</dd></dl>\n"
+ "<hr>");
    }

    public final void printTexCompoundDetail(final PrintWriter wr) {
	String fieldName = Tex.safe(name.getSimple());
	String ns = group.getPackageName() + "." + group.getName();
	String texLabel = Tex.safeTarget(ns + "." + name.getQualified());

	wr.println("\\Sid{" + fieldName + "}");
	wr.println("\\Slabel{:" + texLabel + ":}");
	wr.println(desc.getTexText());
    }
}
