package com.maroontress.sanctuary;

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   ХѿǤ

   globalvariableǤбޤ
*/
public class GlobalVariable {

    /** 롼 */
    private Group group;

    /** type° */
    private String type;

    /** name° */
    private QualifiedName name;

    /** descǤ */
    private Description desc;

    /**
       Хѿޤ

       @param g 롼
       @param elem globalvariable
    */
    public GlobalVariable(final Group g, final Element elem) {
	group = g;
	name = g.expandNS(elem, "name");
	type = g.expandAT(elem, "type");
	g.importTags(type);

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       ѿ̾ޤ

       @return ѿ̾
    */
    public QualifiedName getName() {
	return name;
    }

    /**
       Хѿηɽʸޤ

       @return Хѿηɽʸ
    */
    private String getTypeText() {
	int k = CommentedString.indexOf(type, '#');
	if (k != -1) {
	    return type.substring(0, k) + type.substring(k + 1);
	} else {
	    return type;
	}
    }

    /**
       ƬꤷƥɤϤޤ

       @param wr 饤
       @param prefix Ƭ
    */
    private void printCode(final PrintWriter wr, final String prefix) {
	int k = CommentedString.indexOf(type, '#');
	if (k != -1) {
	    wr.println(prefix
		       + type.substring(0, k)
		       + name
		       + type.substring(k + 1)
		       + ";");
	} else {
	    wr.println(prefix + type + " " + name + ";");
	}
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	printCode(wr, "extern ");
    }

    /**
       ֤ΥإåϤޤ

       @param wr 饤
    */
    public void printStubHeader(final PrintWriter wr) {
	printCode(wr);
    }

    /**
       ֤ΥɤϤޤ

       @param wr 饤
    */
    public void printStubCode(final PrintWriter wr) {
	printCode(wr, "");
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	wr.println(""
+ "<tr>\n"
+ "  <td align=\"right\" valign=\"top\" width=\"1%\">\n"
+ "    <font size=\"-1\">&nbsp;" + group.getHTML(getTypeText())
+ "</font>\n"
+ "  </td>\n"
+ "  <td valign=\"top\">"
+ "<a href=\"#" + name + "\"><b>" + name.getSimple() + "</b></a>" + "<br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	String leftType, rightType;

	int k = CommentedString.indexOf(type, '#');
	if (k == -1) {
	    leftType = type;
	    rightType = "";
	} else {
	    leftType = type.substring(0, k);
	    rightType = type.substring(k + 1);
	}

	wr.print(""
+ "<p><a name=\"" + name + "\"></a>"
+ "<font size=\"+1\"><b>" + name.getSimple() + "</b></font></p>\n"
+ "<table cellpadding=\"0\" cellspacing=\"0\">\n"
+ "  <tr>\n"
+ "    <td nowrap>" + group.getHTML(leftType)
		    + " <b>" + name.getSimple() + "</b>"
		    + group.getHTML(rightType)
		    + "</td>\n"
+ "  </tr>\n"
+ "</table>\n"
+ "<dl>\n"
+ "<dd>" + desc.getText() + "</dd>\n");

	wr.println(""
+ "</dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	String ns = group.getPackageName() + "." + group.getName();
	String texLabel = Tex.safeTarget(ns + "." + name);
	String texName = Tex.safe(name.getSimple());
	String leftType, rightType;

	int k = CommentedString.indexOf(type, '#');
	if (k == -1) {
	    leftType = type;
	    rightType = "";
	} else {
	    leftType = type.substring(0, k);
	    rightType = type.substring(k + 1);
	}
	leftType = group.getTEX(leftType);
	rightType = group.getTEX(rightType);

	// Syntax
	wr.println("");
	wr.println("\\Sid{" + texName + "}");
	wr.println("\\Slabel{:" + texLabel + ":}");
	wr.println("\\nopagebreak");
	wr.println("\\begin{Ssyntax}%");
	wr.println(leftType + " {\\bfseries " + texName + "}" + rightType);
	wr.println("\\end{Ssyntax}");

	// Description
	wr.println("");
	wr.print(desc.getTexText());
    }
}
