package com.maroontress.sanctuary.xclass;

import com.maroontress.sanctuary.Group;
import com.maroontress.sanctuary.QualifiedName;
import java.io.PrintWriter;
import java.util.LinkedList;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
   եɤΥåȤǤ
*/
public class XFields {

    /** եɤΥꥹ */
    private LinkedList<XField> v;

    /**
       եɤΥåȤޤ

       @param g 롼
       @param nodes եɤΥΡɥꥹ
    */
    public XFields(final Group g, final NodeList nodes) {
	v = new LinkedList<XField>();
	String qualifiedPrefix
	    = "struct " + g.getPackageName() + "_impl_" + g.getName() + ".";
	String simplePrefix
	    = "struct impl_" + g.getName() + ".";

	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    XField m = new XField(g, elem);
	    String name = m.getName();
	    QualifiedName names = QualifiedName.intern(qualifiedPrefix + name,
						       simplePrefix + name);
	    g.addKeyword(names);
	    v.add(m);
	}
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println("");
	for (XField m : v) {
	    m.printCode(wr);
	}
    }

    /**
       ΥإåHTMLǽϤޤ

       @param wr 饤
    */
    private void printSummaryHeader(final PrintWriter wr) {
	wr.println("<h2>Field Summary</h2>");
    }

    /**
       ܺ٤ΥإåHTMLǽϤޤ

       @param wr 饤
    */
    private void printDetailHeader(final PrintWriter wr) {
	wr.println("<h2>Field Detail</h2>");
    }

    /**
       ܺ٤ΥإåTeXǽϤޤ

       @param wr 饤
    */
    private void printTexDetailHeader(final PrintWriter wr) {
	wr.println("\\Sfield");
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	printSummaryHeader(wr);
	wr.println(""
+ "    <table width=\"100%\" cellspacing=\"0\" border=\"1\">");
	for (XField m : v) {
	    m.printSummary(wr);
	}
	wr.println(""
+ "    </table>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	printDetailHeader(wr);
	for (XField m : v) {
	    m.printDetail(wr);
	    wr.println("<hr>");
	}
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	printTexDetailHeader(wr);
	for (XField m : v) {
	    m.printTexDetail(wr);
	}
    }
}
